// wherearethepadsDlg.cpp : implementation file
//

#include "stdafx.h"
#include "wherearethepads.h"
#include "wherearethepadsDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#define	XSIZE	417
#define	YSIZE	488

#define	PDAXSIZE	230
#define PDAYSIZE	270
/////////////////////////////////////////////////////////////////////////////
// CWherearethepadsDlg dialog

CWherearethepadsDlg::CWherearethepadsDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CWherearethepadsDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CWherearethepadsDlg)
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CWherearethepadsDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CWherearethepadsDlg)
	DDX_Control(pDX, IDC_COMBO_1STDIGIT, m_comboBox_1stDigit);
	DDX_Control(pDX, IDC_COMBO_2NDDIGIT, m_comboBox_2ndDigit);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CWherearethepadsDlg, CDialog)
	//{{AFX_MSG_MAP(CWherearethepadsDlg)
	ON_WM_PAINT()
	ON_CBN_SELCHANGE(IDC_COMBO_2NDDIGIT, OnSelchangeCombo2nddigit)
	ON_CBN_SELCHANGE(IDC_COMBO_1STDIGIT, OnSelchangeCombo1stdigit)
	ON_WM_LBUTTONDBLCLK()
	ON_WM_LBUTTONUP()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CWherearethepadsDlg message handlers

BOOL CWherearethepadsDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	CenterWindow(GetDesktopWindow());	// center to the hpc screen
	InitializeLocation();
	m_channel = 0;

	// TODO: Add extra initialization here
	
	return true;  // return true  unless you set the focus to a control
}

void CWherearethepadsDlg::InitializeLocation()
{
	m_street3_4[0]	= false;	m_padLocBtm[0].x  = 367;	m_padLocBtm[0].y  = 336;
	m_street3_4[1]	= false;	m_padLocBtm[1].x  = 266;	m_padLocBtm[1].y  = 336;
	m_street3_4[2]	= false;	m_padLocBtm[2].x  = 140;	m_padLocBtm[2].y  = 336;
	m_street3_4[3]	= false;	m_padLocBtm[3].x  = 90;		m_padLocBtm[3].y  = 286;
	m_street3_4[4]	= true;		m_padLocBtm[4].x  = 265;	m_padLocBtm[4].y  = 338;
	m_street3_4[5]	= true;		m_padLocBtm[5].x  = 141;	m_padLocBtm[5].y  = 338;
	m_street3_4[6]	= true;		m_padLocBtm[6].x  = 91;		m_padLocBtm[6].y  = 287;
	m_street3_4[7]	= true;		m_padLocBtm[7].x  = 41;		m_padLocBtm[7].y  = 338;
	m_street3_4[8]	= false;	m_padLocBtm[8].x  = 367;	m_padLocBtm[8].y  = 82;
	m_street3_4[9]	= false;	m_padLocBtm[9].x  = 266;	m_padLocBtm[9].y  = 82;
	m_street3_4[10]	= false;	m_padLocBtm[10].x = 140;	m_padLocBtm[10].y = 82;
	m_street3_4[11] = false;	m_padLocBtm[11].x = 38;		m_padLocBtm[11].y = 82;
	m_street3_4[12]	= false;	m_padLocBtm[12].x = 140;	m_padLocBtm[12].y = 260;
	m_street3_4[13]	= false;	m_padLocBtm[13].x = 38;		m_padLocBtm[13].y = 260;
	m_street3_4[14]	= false;	m_padLocBtm[14].x = 367;	m_padLocBtm[14].y = 260;
	m_street3_4[15]	= false;	m_padLocBtm[15].x = 266;	m_padLocBtm[15].y = 260;
	m_street3_4[16]	= false;	m_padLocBtm[16].x = 90;		m_padLocBtm[16].y = 361;
	m_street3_4[17]	= false;	m_padLocBtm[17].x = 38;		m_padLocBtm[17].y = 336;
	m_street3_4[18]	= false;	m_padLocBtm[18].x = 317;	m_padLocBtm[18].y = 286;
	m_street3_4[19]	= false;	m_padLocBtm[19].x = 190;	m_padLocBtm[19].y = 286;
	m_street3_4[20]	= true;		m_padLocBtm[20].x = 191;	m_padLocBtm[20].y = 364;
	m_street3_4[21]	= true;		m_padLocBtm[21].x = 91;		m_padLocBtm[21].y = 364;
	m_street3_4[22]	= true;		m_padLocBtm[22].x = 364;	m_padLocBtm[22].y = 338;
	m_street3_4[23]	= true;		m_padLocBtm[23].x = 315;	m_padLocBtm[23].y = 364;
	m_street3_4[24]	= true;		m_padLocBtm[24].x = 191;	m_padLocBtm[24].y = 210;
	m_street3_4[25]	= true;		m_padLocBtm[25].x = 91;		m_padLocBtm[25].y = 210;
	m_street3_4[26]	= true;		m_padLocBtm[26].x = 364;	m_padLocBtm[26].y = 262;
	m_street3_4[27]	= true;		m_padLocBtm[27].x = 265;	m_padLocBtm[27].y = 262;
	m_street3_4[28]	= false;	m_padLocBtm[28].x = 367;	m_padLocBtm[28].y = 158;
	m_street3_4[29]	= false;	m_padLocBtm[29].x = 266;	m_padLocBtm[29].y = 158;
	m_street3_4[30]	= false;	m_padLocBtm[30].x = 140;	m_padLocBtm[30].y = 158;
	m_street3_4[31]	= false;	m_padLocBtm[31].x = 90;		m_padLocBtm[31].y = 209;
	m_street3_4[32]	= true;		m_padLocBtm[32].x = 364;	m_padLocBtm[32].y = 82;
	m_street3_4[33]	= true;		m_padLocBtm[33].x = 265;	m_padLocBtm[33].y = 82;
	m_street3_4[34]	= true;		m_padLocBtm[34].x = 141;	m_padLocBtm[34].y = 82;
	m_street3_4[35]	= true;		m_padLocBtm[35].x = 41;		m_padLocBtm[35].y = 82;
	m_street3_4[36]	= true;		m_padLocBtm[36].x = 364;	m_padLocBtm[36].y = 415;
	m_street3_4[37]	= true;		m_padLocBtm[37].x = 265;	m_padLocBtm[37].y = 415;
	m_street3_4[38]	= true;		m_padLocBtm[38].x = 141;	m_padLocBtm[38].y = 415;
	m_street3_4[39]	= true;		m_padLocBtm[39].x = 41;		m_padLocBtm[39].y = 415;
	m_street3_4[40]	= false;	m_padLocBtm[40].x = 90;		m_padLocBtm[40].y = 134;
	m_street3_4[41]	= false;	m_padLocBtm[41].x = 38;		m_padLocBtm[41].y = 158;
	m_street3_4[42]	= false;	m_padLocBtm[42].x = 317;	m_padLocBtm[42].y = 134;
	m_street3_4[43]	= false;	m_padLocBtm[43].x = 190;	m_padLocBtm[43].y = 134;
	m_street3_4[44]	= true;		m_padLocBtm[44].x = 315;	m_padLocBtm[44].y = 287;
	m_street3_4[45]	= true;		m_padLocBtm[45].x = 191;	m_padLocBtm[45].y = 287;
	m_street3_4[46]	= true;		m_padLocBtm[46].x = 141;	m_padLocBtm[46].y = 262;
	m_street3_4[47]	= true;		m_padLocBtm[47].x = 41;		m_padLocBtm[47].y = 262;
	m_street3_4[48]	= false;	m_padLocBtm[48].x = 140;	m_padLocBtm[48].y = 412;
	m_street3_4[49]	= false;	m_padLocBtm[49].x = 38;		m_padLocBtm[49].y = 412;
	m_street3_4[50]	= false;	m_padLocBtm[50].x = 367;	m_padLocBtm[50].y = 412;
	m_street3_4[51]	= false;	m_padLocBtm[51].x = 266;	m_padLocBtm[51].y = 412;
	m_street3_4[52]	= true;		m_padLocBtm[52].x = 141;	m_padLocBtm[52].y = 160;
	m_street3_4[53]	= true;		m_padLocBtm[53].x = 41;		m_padLocBtm[53].y = 160;
	m_street3_4[54]	= true;		m_padLocBtm[54].x = 315;	m_padLocBtm[54].y = 210;
	m_street3_4[55]	= true;		m_padLocBtm[55].x = 265;	m_padLocBtm[55].y = 160;
	m_street3_4[56]	= false;	m_padLocBtm[56].x = 317;	m_padLocBtm[56].y = 361;
	m_street3_4[57]	= false;	m_padLocBtm[57].x = 190;	m_padLocBtm[57].y = 361;
	m_street3_4[58]	= false;	m_padLocBtm[58].x = 317;	m_padLocBtm[58].y = 209;
	m_street3_4[59]	= false;	m_padLocBtm[59].x = 190;	m_padLocBtm[59].y = 209;
	m_street3_4[60]	= true;		m_padLocBtm[60].x = 364;	m_padLocBtm[60].y = 160;
	m_street3_4[61]	= true;		m_padLocBtm[61].x = 315;	m_padLocBtm[61].y = 134;
	m_street3_4[62]	= true;		m_padLocBtm[62].x = 191;	m_padLocBtm[62].y = 134;
	m_street3_4[63]	= true;		m_padLocBtm[63].x = 91;		m_padLocBtm[63].y = 134;
}


void CWherearethepadsDlg::OnPaint() 
{
		CPaintDC dc(this);

		CDC BufferDC;
		BufferDC.CreateCompatibleDC(&dc);

		// ȭ DC ȣȯ ִ ޸ Ʈ 
		CBitmap bmpBuffer;
		bmpBuffer.CreateCompatibleBitmap(&dc, XSIZE, YSIZE);

		// ޸ DC ޸ Ʈ 
		CBitmap *pOldBitmap = (CBitmap *)BufferDC.SelectObject(&bmpBuffer);
		CPen	pRedPen (PS_SOLID ,5,RGB(255,0,0));
		CPen*	pOldBlackPen;

		pOldBlackPen = BufferDC.SelectObject(&pRedPen);

		HBITMAP	hbitmap;
		if(m_street3_4[m_channel])	hbitmap = ::LoadBitmap(::AfxGetInstanceHandle(), MAKEINTRESOURCE(IDB_BITMAP_HSD800_1));
		if(!m_street3_4[m_channel])	hbitmap = ::LoadBitmap(::AfxGetInstanceHandle(), MAKEINTRESOURCE(IDB_BITMAP_HSD800_2));

		HDC hMemDC = ::CreateCompatibleDC(NULL);
		SelectObject(hMemDC, hbitmap);
		::StretchBlt(BufferDC.m_hDC, 0, 0, XSIZE, YSIZE, hMemDC, 0, 0, XSIZE, YSIZE,SRCCOPY);
		::DeleteDC(hMemDC);
		::DeleteObject(hbitmap);

		BufferDC.SelectObject(GetStockObject(NULL_BRUSH));

		BufferDC.Ellipse(	m_padLocBtm[m_channel].x-10, m_padLocBtm[m_channel].y-10 , 
							m_padLocBtm[m_channel].x+10, m_padLocBtm[m_channel].y+10);

		dc.StretchBlt(0, 0, PDAXSIZE, PDAYSIZE, &BufferDC, 0, 0, XSIZE, YSIZE, SRCCOPY);

		// DC 
		BufferDC.SelectObject(pOldBlackPen);
		BufferDC.SelectObject(pOldBitmap);
}

void CWherearethepadsDlg::OnSelchangeCombo2nddigit() 
{
	UpdateData(TRUE);
	int firstDigit = m_comboBox_1stDigit.GetCurSel();
	int secondDigit = m_comboBox_2ndDigit.GetCurSel();
	if(firstDigit == -1) {
		firstDigit = 0;
		m_comboBox_1stDigit.SetCurSel(firstDigit);
	}
	if(secondDigit == -1) {
		secondDigit = 0;
		m_comboBox_2ndDigit.SetCurSel(secondDigit);
	}
	m_channel = firstDigit*10 + secondDigit;
	if(m_channel > 63) {
		AfxMessageBox(_T("Please select channel between 0 ~ 63.."));
		return;
	}
	UpdateData(FALSE);
	Invalidate();	
}

//AfxMessageBox(_T("Stylus..."));

void CWherearethepadsDlg::OnSelchangeCombo1stdigit() 
{
	UpdateData(TRUE);
	int firstDigit = m_comboBox_1stDigit.GetCurSel();
	int secondDigit = m_comboBox_2ndDigit.GetCurSel();
	if(firstDigit == -1) {
		firstDigit = 0;
		m_comboBox_1stDigit.SetCurSel(firstDigit);
	}
	if(secondDigit == -1) {
		secondDigit = 0;
		m_comboBox_2ndDigit.SetCurSel(secondDigit);
	}
	m_channel = firstDigit*10 + secondDigit;
	if(m_channel > 63) {
		AfxMessageBox(_T("Please select channel between 0 ~ 63.."));
		return;
	}
	UpdateData(FALSE);
	Invalidate();	
}

void CWherearethepadsDlg::OnLButtonUp(UINT nFlags, CPoint point) 
{
	return;

	// TODO: Add your message handler code here and/or call default
//	AfxMessageBox(_T("Stylus was tapped.."));
	int stylusXLoc = (int)(point.x * XSIZE/PDAXSIZE);
	int stylusYLoc = (int)(point.y * YSIZE/PDAYSIZE);

	int chSelectedIn3rdStreet;
	int chSelectedIn4thStreet;
	double minDist3rdStreet = 500;
	double minDist4thStreet = 500;

	for(int ch=0; ch<HSD800_MAXCH; ch++){
		double dist = sqrt((stylusXLoc - m_padLocBtm[ch].x)^2 + (stylusYLoc - m_padLocBtm[ch].y)^2);
		if(m_street3_4[ch]){
			if(dist < minDist3rdStreet){
				minDist3rdStreet = dist;
				chSelectedIn3rdStreet = ch;
			}
		}else{
			if(dist < minDist4thStreet){
				minDist4thStreet = dist;
				chSelectedIn4thStreet = ch;
			}
		}
	}

	CString chLoc;
//	chLoc.Format(_T("channel %d & %d on selected"), chSelectedIn3rdStreet, chSelectedIn4thStreet);
	chLoc.Format(_T("ch %d %d\nloc %d  %d\nDist %f %f"), 
		chSelectedIn3rdStreet, chSelectedIn4thStreet, stylusXLoc, stylusYLoc, minDist3rdStreet, minDist4thStreet);
	AfxMessageBox(chLoc);
	
	CDialog::OnLButtonUp(nFlags, point);
}
